#Upload of the data file for one single year (2005 in this case)

pr1=scan("41010h2005.txt", skip=1)
pr1=array(pr1,dim=c(18,16378))

#Extraction of the wave data
pr2=pr1[9,]
pr2[pr2==99]=NA

#Observation time step in hours
pr3=pr1[2,]
pr3[pr3==1]=0
pr3[pr3==2]=31*24
pr3[pr3==3]=(31+28)*24
pr3[pr3==4]=(31+28+31)*24
pr3[pr3==5]=(31+28+31+30)*24
pr3[pr3==6]=(31+28+31+30+31)*24
pr3[pr3==7]=(31+28+31+30+31+30)*24
pr3[pr3==8]=(31+28+31+30+31+30+31)*24
pr3[pr3==9]=(31+28+31+30+31+30+31+31)*24
pr3[pr3==10]=(31+28+31+30+31+30+31+31+30)*24
pr3[pr3==11]=(31+28+31+30+31+30+31+31+30+31)*24
pr3[pr3==12]=(31+28+31+30+31+30+31+31+30+31+30)*24
pr3=pr3+(pr1[3,]-1)*24
pr3=pr3+(pr1[4,])
pr3=pr3+(pr1[5,]/60)

plot(pr3,pr2,type="l")
grid()

#Other years can be updated and merged to the above data set if appropriate

#Upload of the code to "manually" extract the POT
source("code-extraction-peaks.r")

#Now let's compare the results with clust, the package to extract peaks over threshold from the POT package, which should be preliminarily installed with the instructions 
#install.packages("POT")
#library("POT")


#Construction of the matrix to run clust
obs=pr2
time=pr3

dati=cbind(obs,time)

variab=clust(dati,3,clust.max=T)

#Goodness of fit plots
#Sets the number of plots in the page to 4
par(mfrow=c(1,3))

#Mean life residual plot
mrlplot(variab[,2], xlim = c(3, max(variab[,2])))
#Plot of parameter estimates for the GPD at different thrreshold values
tcplot(variab[,2], u.range = c(3, max(variab[,2])))

#Fitting of the GPD with the pwmu
obs=variab[,2]
pwmu=fitgpd(obs,5,"pwmu")
pwmu$param

#Diagnostic
par(mfrow=c(2,2))
plot(pwmu)




